package com.liang.dao;

import com.liang.entity.SysUserPost;
import com.liang.vo.PostXmSelect;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysUserPost)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-01 19:44:13
 */
public interface SysUserPostDao {

    /**
     * 通过ID查询单条数据
     *
     * @param userId 主键
     * @return 实例对象
     */
    SysUserPost queryById(Integer userId);

    /**
     * 查询指定行数据
     *
     * @param sysUserPost 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SysUserPost> queryAllByLimit(SysUserPost sysUserPost, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysUserPost 查询条件
     * @return 总行数
     */
    long count(SysUserPost sysUserPost);

    /**
     * 新增数据
     *
     * @param sysUserPost 实例对象
     * @return 影响行数
     */
    int insert(SysUserPost sysUserPost);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysUserPost> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysUserPost> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysUserPost> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysUserPost> entities);

    /**
     * 修改数据
     *
     * @param sysUserPost 实例对象
     * @return 影响行数
     */
    int update(SysUserPost sysUserPost);

    /**
     * 通过主键删除数据
     *
     * @param userId 主键
     * @return 影响行数
     */
    int deleteById(Integer userId);

    /**
     * 获取全部岗位信息XmSelect列表
     *
     * @return
     */
    List<PostXmSelect> listAllPost();

    /**
     * 获取用户岗位信息XmSelect列表
     *
     * @param userId
     * @return
     */
    List<PostXmSelect> listPostByUserId(Integer userId);

    int deleteUserPostByUserId(Integer userId);

    int batchSaveUserPost(List<SysUserPost> list);

    /**
     * 获取岗位用户列表
     *
     * @return
     */
    List<SysUserPost> getPostUserList(Map<String, String> paraMap);

    /**
     * 获取用户岗位列表
     *
     * @return
     */
    List<SysUserPost> getUserPostList(Map<String, String> paraMap);

    List<SysUserPost> getPostId(Integer userId);
}

